/*
 * ResistorBandShape.fx
 *
 * Created on 01.09.2009, 18:27:14
 */

package resistorapplet;

import javafx.scene.CustomNode;
import javafx.scene.Node;
import javafx.scene.Group;
import javafx.scene.shape.*;
import javafx.scene.paint.*;
import javafx.scene.Cursor;
import javafx.scene.input.MouseEvent;
import javafx.scene.input.MouseButton;
/**
 * @author Sun2k
 */

public-read def Colors : Color[] = [ Color.TRANSPARENT, Color.SILVER,
        Color.GOLD, Color.BLACK, Color.BROWN, Color.RED, Color.ORANGE,
        Color.YELLOW, Color.GREEN, Color.BLUE, Color.PURPLE, Color.GRAY, Color.WHITE];

public-read def ColorCode : Integer[] = [ -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9];

public var CurrentBandColors : Color[];

public class ResistorBandShape extends CustomNode {

    
    public def NumOfColors = sizeof(Colors);

    public var currentColor : Color = Color.SILVER;

    public var colorIndex : Integer = 1;

    public var colorCode : Integer;

    public-init var xOffset: Number;

   
    protected override function create() : Node {
        return Group {
            content : [
                Rectangle {
                    x: 160 + xOffset
                    y: 41.0
                    width: 20
                    height: 58
                    fill: bind currentColor
                    cursor: Cursor.HAND;
                    onMouseClicked : function(evt : MouseEvent) : Void {
                        // left click -> iterate forward through colors
                        if (evt.button == MouseButton.PRIMARY)
                        {
                            if (colorIndex >= NumOfColors-1)
                                colorIndex = -1;
                            currentColor = Colors[++colorIndex];
                            
                        }
                        // right click -> iterate backwards through colors
                        else if (evt.button == MouseButton.SECONDARY)
                        {
                            if (colorIndex == 0)
                                colorIndex = NumOfColors;
                            currentColor = Colors[--colorIndex];
                        }
                        colorCode = ColorCode[colorIndex];

                        resistorapplet.Main.UpdateBands();
                        
                    } // end onMouseClicked
                 }
            ]
        }   // end Group
    }   // end create

}
